/**
* ============================================
* File type: Main
* LazyAnimate - v0.9
* Copyright © 2017-2018 
*
* @author: Matteo Montanari <matteo@italinux.com>
*
* TERMS OF USE
* Open source under the MIT License.
*
* Permission is hereby granted, free of charge, to any person obtaining
* a copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
* IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
* ============================================
* Waypoints required Animations
* ============================================
*
* Start Animations Loop
*/
(function($){$(".scroll").click(function(e){e.preventDefault();var speedFactor=2;var animDurationMsecsDefault=400;var baseOffset=0;if(document.querySelector("section.static.menu")!==null){baseOffset=-50}var offsetDefault={desktop:70,mobile:50};var offsetConfig={};var thisHash=this.hash.substring(1);switch(thisHash){case"what-i-do-more":offsetConfig={desktop:165};thisHash="what-i-do";break;case"curriculum-vitae":case"curriculum-vitae-skills":case"curriculum-vitae-resume":offsetConfig={desktop:120,mobile:150};break;case"contacts-more":case"contacts-more-mobile":case"contacts-more-address":case"contacts-more-email":offsetConfig={desktop:120,mobile:150};break}var thisHandler="#"+thisHash;if($(thisHandler).length){var thisHandlerOffset=$(thisHandler).first().offset().top;var thisElementOffset=$(this).offset().top;var animDurationMsecs=Math.ceil((thisHandlerOffset-thisElementOffset)/speedFactor);var thisAnimDurationMsecs=animDurationMsecs<animDurationMsecsDefault?animDurationMsecsDefault:animDurationMsecs;var isMobile=window.matchMedia("only screen and (max-width: 800px)");var thisOffsetDefault=isMobile.matches?offsetDefault.mobile:offsetDefault.desktop;var thisOffsetConfig=isMobile.matches?"mobile"in offsetConfig?offsetConfig.mobile:0:"desktop"in offsetConfig?offsetConfig.desktop:0;var postOffset=baseOffset+(thisOffsetConfig?thisOffsetConfig:thisOffsetDefault);$("html, body").animate({scrollTop:thisHandlerOffset-postOffset},{duration:thisAnimDurationMsecs,easing:"swing",complete:function(){$("nav").find(".hamburger").removeClass("is-active");$("nav").find(".fixed").removeClass("animated").fadeOut(250,"swing",function(){$(this).removeClass("fixed").addClass("animated")})}})}});$.fn.lazyAnimate=function(options){init(options);function init(options){var thisHash=$(location).attr("hash").substring(1);var parentHash=thisHash.substr(0,thisHash.lastIndexOf("-"));for(var sectionID in options){var thisObject=options[sectionID];for(var targetEl in thisObject){if(!thisObject.hasOwnProperty(targetEl))continue;var objsOpts={};switch(getDepthOfObject(thisObject[targetEl])){case 1:objsOpts[0]={element:".pre-hand."+sectionID,target:"*[data-animation='"+targetEl+"']",effect:thisObject[targetEl].effect,delay:thisObject[targetEl].delay,offset:thisObject[targetEl].offset};break;case 2:for(var id in thisObject[targetEl]){objsOpts[id]={element:".pre-hand."+sectionID,target:"*[data-animation='"+targetEl+"']:eq("+id+")",effect:thisObject[targetEl][id].effect,delay:thisObject[targetEl][id].delay,offset:thisObject[targetEl][id].offset}}break;default:}if(!thisHash){setObjectsOpts(objsOpts)}else{if(thisHash==sectionID){setObjectsOpts(objsOpts)}else{if(parentHash==sectionID){setObjectsOpts(objsOpts)}else{setObjectsNoAnimations(objsOpts)}}}}}return true}function getDepthOfObject(obj){var level=1;for(var key in obj){if(!obj.hasOwnProperty(key))continue;if(typeof obj[key]=="object"&&obj[key]!==null){var depth=getDepthOfObject(obj[key])+1;level=Math.max(depth,level)}}return level}function setObjectsOpts(objsOpts){for(var objID in objsOpts){var thisElement=objsOpts[objID].element;var thisTarget=objsOpts[objID].target;var thisEffect=objsOpts[objID].effect;var thisDelay=objsOpts[objID].delay;var thisOffset=objsOpts[objID].offset;switch(thisEffect){case"bounceIn":case"bounceInUp":case"bounceInLeft":case"bounceInRight":case"flipInX":case"flipInY":case"fadeIn":case"fadeInLeft":case"fadeInRight":case"fadeInLeftBig":case"fadeInRightBig":case"fadeInUp":case"fadeInUpBig":case"lightSpeedIn":case"zoomIn":case"zoomInRight":case"zoomInUp":case"zoomInDown":case"rotateIn":case"pulse":case"bounce":case"swing":doObjectsOptsHideAnimation(thisElement,thisTarget);break}switch(thisDelay){case 0:break;default:doObjectsOptsPrepareForAnimation(thisElement,thisTarget,thisDelay)}doObjectsOptsDoAnimation(thisElement,thisTarget,thisEffect,thisOffset)}}function doObjectsOptsHideAnimation(thisElement,thisTarget){$(thisElement).each(function(){$(this).find(thisTarget).not("[class~='disabled']").addClass("nopaque")})}function doObjectsOptsPrepareForAnimation(thisElement,thisTarget,thisDelay){$(thisElement).each(function(){$(this).find(thisTarget).not("[class~='disabled']").addClass("delay-"+thisDelay.toString().replace(/\./g,"")+"s")})}function doObjectsOptsDoAnimation(thisElement,thisTarget,thisEffect,thisOffset){$(thisElement).each(function(){$(this).find(thisTarget).waypoint({element:$(this),handler:function(e,d){$(this.element).not("[class~='disabled']").removeClass("nopaque animated "+thisEffect).addClass("animated "+thisEffect);this.destroy()},offset:function(d){var topOffset=200;var offset;switch(thisOffset){case"bottom":offset=$(window).height()-this.element.clientHeight;break;default:offset=topOffset+thisOffset;break}return offset}})})}function doObjectsNoAnimations(thisElement,thisTarget){$(thisElement).each(function(){$(this).find(thisTarget).not("[class~='disabled']").removeClass("nopaque")})}function setObjectsNoAnimations(objsOpts){for(var objID in objsOpts){doObjectsNoAnimations(objsOpts[objID].element,objsOpts[objID].target)}}}})(jQuery);